﻿Imports System.Runtime.InteropServices
Imports System.ComponentModel
Imports System.Windows.Forms
Imports AddinExpress.MSO
Imports System.Diagnostics

Namespace ReplyAllContextMenu2003
    'Add-in Express Add-in Module
    <GuidAttribute("0A66A05B-80DB-4E5F-8F55-D064E4A70EBD"), ProgIdAttribute("ReplyAllContextMenu2003-vb.AddinModule")> _
    Public Class AddinModule
        Inherits AddinExpress.MSO.ADXAddinModule

        Friend WithEvents AdxBuiltInControl1 As AddinExpress.MSO.ADXBuiltInControl
        Friend WithEvents adxOutlookEvents As AddinExpress.MSO.ADXOutlookAppEvents
#Region " Component Designer generated code. "
        'Required by designer
        Private components As System.ComponentModel.IContainer

        'Required by designer - do not modify
        'the following method
        Private Sub InitializeComponent()
            Me.components = New System.ComponentModel.Container
            Me.AdxBuiltInControl1 = New AddinExpress.MSO.ADXBuiltInControl(Me.components)
            Me.adxOutlookEvents = New AddinExpress.MSO.ADXOutlookAppEvents(Me.components)
            '
            'AdxBuiltInControl1
            '
            Me.AdxBuiltInControl1.CommandBar = Nothing
            Me.AdxBuiltInControl1.ControlTag = "097dffcd-99aa-4799-967e-f5719801ed52"
            Me.AdxBuiltInControl1.Id = 354
            '
            'adxOutlookEvents
            '
            '
            'AddinModule
            '
            Me.AddinName = "ReplyAllContextMenu2003-vb"
            Me.SupportedApps = AddinExpress.MSO.ADXOfficeHostApp.ohaOutlook

        End Sub

#End Region

#Region " Add-in Express automatic code "

        'Required by Add-in Express - do not modify
        'the methods within this region

        Public Overrides Function GetContainer() As System.ComponentModel.IContainer
            If components Is Nothing Then
                components = New System.ComponentModel.Container
            End If
            GetContainer = components
        End Function

        <ComRegisterFunctionAttribute()> _
        Public Shared Sub AddinRegister(ByVal t As Type)
            AddinExpress.MSO.ADXAddinModule.ADXRegister(t)
        End Sub

        <ComUnregisterFunctionAttribute()> _
        Public Shared Sub AddinUnregister(ByVal t As Type)
            AddinExpress.MSO.ADXAddinModule.ADXUnregister(t)
        End Sub

        Public Overrides Sub UninstallControls()
            MyBase.UninstallControls()
        End Sub

#End Region

        Public Sub New()
            MyBase.New()

            Application.EnableVisualStyles()
            'This call is required by the Component Designer
            InitializeComponent()

            'Please add any initialization code to the AddinInitialize event handler

        End Sub

        Public Shared Shadows ReadOnly Property CurrentInstance() As AddinModule
            Get
                Return CType(AddinExpress.MSO.ADXAddinModule.CurrentInstance, AddinModule)
            End Get
        End Property

        Public ReadOnly Property OutlookApp() As Outlook._Application
            Get
                Return CType(HostApplication, Outlook._Application)
            End Get
        End Property

        Private waitForInspector As Boolean = False
        Private inspectorStopper As InspectorStopper = Nothing
        Private replyAllChecker As ReplyAllChecker = Nothing
        Private EntryID As String = ""
        Private Const WM_USER As Integer = &H400
        Private WM_Reply As Integer = WM_USER + 1000

        Private Sub AddinModule_AddinStartupComplete(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.AddinStartupComplete
            Debug.Print("The AddinStartupComplete event has occured.")
            Debug.Print("The add-in has been loaded by Outlook " & Me.HostMajorVersion.ToString())

            ' This creates an instance of the class that handles the events of an Outlook item
            replyAllChecker = New ReplyAllChecker(Me)
            inspectorStopper = New InspectorStopper(Me)
        End Sub

        Private Sub AddinModule_AddinBeginShutdown(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.AddinBeginShutdown
            Debug.Print("The AddinBeginShutdown event has occured.")
            ReplyAllChecker = Nothing
            InspectorStopper = Nothing
        End Sub

        ''' <summary>
        ''' Handles clicking on any Reply button in Outlook
        ''' </summary>
        Private Sub AdxBuiltInControl1_ActionEx(ByVal sender As System.Object, ByVal e As AddinExpress.MSO.ADXCancelEventArgs) Handles AdxBuiltInControl1.ActionEx
            Debug.Print("ProcessReplyButtonClick. A Reply button is clicked.")
            If Me.HostMajorVersion <> 11 Then
                Debug.Print("Only handle Outlook 2003")
                Return
            End If
            Debug.Print("Make sure that the Reply button is located on 'Context Menu'.")

            Dim replyButton As Office.CommandBarButton = TryCast(e.Control, Office.CommandBarButton)
            Dim contextMenu As Office.CommandBar = replyButton.Parent
            If contextMenu.Name = "Context Menu" Then
                Debug.Print("Step 1. Open the right-clicked item and cancel the Reply action")
                Dim controls As Office.CommandBarControls = contextMenu.Controls
                Dim buttonOpen As Office.CommandBarControl = controls("Open")
                If buttonOpen IsNot Nothing Then
                    If buttonOpen.Visible Then
                        buttonOpen.Execute()

                        Debug.Print("Cancel the Reply action")
                        e.Cancel = True
                        waitForInspector = True
                    End If
                    Marshal.ReleaseComObject(buttonOpen)
                    buttonOpen = Nothing
                End If
                Marshal.ReleaseComObject(controls)
                controls = Nothing
            End If
            Marshal.ReleaseComObject(contextMenu)
            contextMenu = Nothing
            Debug.Print("ProcessReplyButtonClick. Exit")
        End Sub

        Private Sub adxOutlookEvents_NewInspector(ByVal sender As System.Object, ByVal inspector As System.Object, ByVal folderName As System.String) Handles adxOutlookEvents.NewInspector
            Debug.Print("adxOutlookEvents_NewInspector")
            If waitForInspector Then
                Debug.Print("Step 2. Get the EntryID of the right-clicked item; prevent the item from opening")
                Dim item As Object = (TryCast(inspector, Outlook._Inspector)).CurrentItem
                If TypeOf item Is Outlook.MailItem Then
                    Dim mail As Outlook.MailItem = TryCast(item, Outlook.MailItem)
                    EntryID = mail.EntryID
                    Debug.Print("Save the right-clicked item's EntryID")

                    Debug.Print("Prevent the right-clicked item from opening")
                    ' inspectorStopper cancels the Open event of the item
                    inspectorStopper.ConnectTo(mail, True)

                    Debug.Print("Initiate Step 3.")
                    Me.SendMessage(WM_Reply)
                Else
                    Debug.Print("adxOutlookEvents_NewInspector. Oops! This is not a MailItem... :( ")
                End If
                waitForInspector = False
            End If
            Debug.Print("adxOutlookEvents_NewInspector. Exit")
        End Sub

        ''' <summary>
        ''' When the WM_Reply window message is received, retrieves the email and creates a reply email
        ''' </summary>
        Private Sub AddinModule_OnSendMessage(ByVal sender As System.Object, ByVal e As AddinExpress.MSO.ADXSendMessageEventArgs) Handles MyBase.OnSendMessage
            If e.Message = WM_Reply Then
                Debug.Print("AddinModule_OnSendMessage. Handle WM_Reply")
                If Me.EntryID <> "" Then
                    Debug.Print("Step 3. Re-get the right-clicked item and create a reply")
                    Dim item As Object = GetItemFromEntryID()
                    If item IsNot Nothing Then
                        If TypeOf item Is Outlook.MailItem Then
                            Dim mail As Outlook.MailItem = TryCast(item, Outlook.MailItem)
                            Debug.Print("Connecting replyAllChecker to the right-clicked item.")
                            replyAllChecker.ConnectTo(mail, True)

                            Dim reply As Outlook.MailItem = Nothing

                            Try
                                ' mail.Reply() generates the Reply event, it is processed by replyAllChecker
                                reply = mail.Reply()
                                If reply IsNot Nothing Then
                                    reply.Display(False)
                                    Debug.Print("The reply is created and displayed sucessfully")
                                End If
                            Catch ex As Exception
                                Debug.Print(ex.Message)
                            Finally
                                If reply IsNot Nothing Then
                                    Marshal.ReleaseComObject(reply)
                                End If
                            End Try

                            Debug.Print("Disconnecting replyAllChecker from the previously connected item.")
                            replyAllChecker.RemoveConnection()
                        End If
                    End If
                End If
                Debug.Print("AddinModule_OnSendMessage. Exit")
            End If
        End Sub

        Private Function GetItemFromEntryID() As Object
            Dim item As Object = Nothing
            Dim ns As Outlook.NameSpace = OutlookApp.Session
            Try
                item = ns.GetItemFromID(Me.EntryID, Type.Missing)
            Catch
                Debug.Print("GetItemFromEntryID. The item has been moved or deleted")
            End Try
            Marshal.ReleaseComObject(ns)
            ns = Nothing
            Return item
        End Function

    End Class
End Namespace

